﻿
@{
    ViewBag.Title = "Bank List";
}
<!-- Content Header (Page header) -->
<section class="content-header">
    <h1>
        Master
        <small>Banks</small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="/"><i class="fa fa-dashboard"></i> Home</a></li>
        <li class="active">Banks</li>
    </ol>
</section>
<!-- Main content -->
<section class="content">
    <div id="data-list" class="box">
        <div class="box-header with-border">
            <h3 class="box-title">Banks List</h3>
            <div class="box-tools pull-right">
                <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                        title="Collapse">
                    <i class="fa fa-minus"></i>
                </button>
                <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                    <i class="fa fa-times"></i>
                </button>
            </div>
        </div>
        <div class="box-body">
            <div id="grid-bank"></div>
        </div>
        <!-- /.box-body -->
        <div class="box-footer text-right">
            <button id="btn-add" type="button" class="btn btn-primary"><i class="fa fa-plus"></i> Add New</button>
        </div>
        <!-- /.box-footer-->
    </div>
    <!-- /.box -->
    <div id="data-detail" class="box" style="display: none">
        <form name="form1">
            <div class="box-header with-border">
                <h3 class="box-title">Bank Detail</h3>
                <div class="box-tools pull-right">
                    <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                            title="Collapse">
                        <i class="fa fa-minus"></i>
                    </button>
                    <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                        <i class="fa fa-times"></i>
                    </button>
                </div>
            </div>
            <div class="box-body">
                <div class="form-horizontal">
                    <div class="form-group">
                        <div class="col-md-2 control-label">Bank ID</div>
                        <div class="col-md-3">
                            <input data-bind="BankID" type="text" name="BankID" class="form-control" readonly/>
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-2 control-label">Bank Name</div>
                        <div class="col-md-3">
                            <input data-bind="BankName" type="text" name="BankName" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Head Office</div>
                        <div class="col-md-3">
                            <input data-bind="HeadOffice" type="text" name="HeadOffice" class="form-control" />
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-2 control-label">Contact Name</div>
                        <div class="col-md-3">
                            <input data-bind="ContactName" type="text" name="ContactName" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Contact Phone</div>
                        <div class="col-md-3">
                            <input data-bind="ContactPhone" type="text" name="ContactPhone" class="form-control" />
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-2 control-label">Contact Email</div>
                        <div class="col-md-3">
                            <input data-bind="ContactEmail" type="text" name="ContactEmail" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">AccountID</div>
                        <div class="col-md-3">
                            <div class="input-group">
                                <input data-bind="AccountID" type="text" name="AccountID" class="form-control" readonly/>
                                <div class="input-group-btn">
                                    <button id="btn-select-account" type="button" class="btn btn-primary"><i class="fa fa-user"></i></button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="box-footer text-center">
                <button id="btn-back" type="button" class="btn btn-default"><i class="fa fa-chevron-left"></i> Back</button>
                <button id="btn-save" type="button" class="btn btn-primary"><i class="fa fa-save"></i> Save</button>
            </div>
        </form>
    </div>
</section>
<!-- /.content-->
<div id="select-account" class="modal fade">
    <div class="modal-dialog modal-lg">
        <div class="modal-body">
            <div class="box box-primary">
                <div class="box-header with-border">
                    Select Account
                    <span class="close" style="color: white; opacity:1" data-dismiss="modal">&times;</span>
                </div>
                <div class="box-body">
                    <div id="grid-account"></div>
                </div>
                <div class="box-footer text-center">
                    <button type="button" class="btn btn-default" data-dismiss="modal">
                        <i class="fa fa-remove"></i> Close
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>
@section scripts
{
    <script>
    (function () {
        function Bank() {
            return {
                BankID: 0,
                BankName: '',
                HeadOffice: '',
                ContactName: '',
                ContactPhone: '',
                ContactEmail: '',
                AccountID: '',
            }
        }
        var scope = (function () {
            return Bind({
                bank: new Bank()
            }, {
                    "bank.BankID": "[data-bind='BankID']",
                    "bank.BankName": "[data-bind='BankName']",
                    "bank.HeadOffice": "[data-bind='HeadOffice']",
                    "bank.ContactName": "[data-bind='ContactName']",
                    "bank.ContactPhone": "[data-bind='ContactPhone']",
                    "bank.ContactEmail": "[data-bind='ContactEmail']",
                    "bank.AccountID": "[data-bind='AccountID']"
                });
        }());
        var gridAccount = gridview("grid-account", {
            url: "/Account/Paging",
            columns: [
                {
                    text: "", render: function (c) {
                        var tmpl = "<a action='select'><i class='fa fa-check'></i></a>";
                        return tmpl;
                    }
                },
                { field: "AccountID", text: "Account ID", sortable: true },
                { field: "FirstName", text: "First Name", sortable: true },
                { field: "Email", text: "Email", sortable: true },
                { field: "AccountType", text: "Account Type", sortable: true },
                { field: "DateOfBirth", text: "Date Of Birth", sortable: true },
                { field: "IDNumber", text: "ID Number", sortable: true },
                { field: "City", text: "City", sortable: true }
            ],
            fieldKey: "AccountID",
            select: function (bnk) {
                scope.bank.AccountID = bnk.AccountID;
                scope.bank = bnk;
                $("#select-account").modal("hide");
            },
        });

        var state = "new";

        var grid = gridview("grid-bank", {
            url: "/Bank/Paging",
            columns: [
                {
                    text: "", render: function (c) {
                        var tmpl = "<a action='view'><i class='fa fa-search'></i></a>";
                        tmpl += "<a action='edit'><i class='fa fa-edit'></i></a>";
                        tmpl += "<a action='remove'><i class='fa fa-trash'></i></a>";
                        return tmpl;
                    }
                },
                { field: "BankID", text: "Bank ID", sortable: true },
                { field: "BankName", text: "Bank Name", sortable: true },
                { field: "HeadOffice", text: "Head Office", sortable: true },
                { field: "ContactName", text: "Contact Name", sortable: true },
                { field: "ContactPhone", text: "Contact Phone", sortable: true },
                { field: "ContactEmail", text: "Contact Email", sortable: true },
                { field: "AccountID", text: "AccountID", sortable: true }
            ],
            fieldKey: "BankID",
            view: view,
            edit: edit,
            remove: remove
        });

        function view(bnk) {
            scope.bank = bnk;
            showDetail();
            $("[data-bind]").attr("disabled", true);
            $("#btn-save").hide();
        }

        function edit(bnk) {
            state = "update";
            scope.bank = bnk;
            showDetail();
            $("[data-bind]").attr("disabled", false);
            $("[data-bind='BankID']").attr("disabled", true);
            $("#btn-save").show();
        }

        function addNew() {
            state = "new";
            scope.bank = new Bank();
            showDetail();
            $("[data-bind]").attr("disabled", false);
            $("#btn-save").show();
        }

        function remove(bnk) {
            Swal.fire({
                title: "Confirmation",
                text: "Are you sure?",
                type: "warning",
                showCancelButton: true,
                confirmButtonText: "YES",
                cancelButtonText: "NO",
                confirmButtonColor: "red"
            })
                .then(function (r) {
                    if (r.value) {
                        axios.post("/Bank/Delete", { id: bnk.BankID })
                            .then(function (res) { return res.data; }, function (err) { console.log("Err: ", er); })
                            .then(function (res) {
                                if (res.meta.success) {
                                    Swal.fire("Success", "Delete data success", "success")
                                        .then(function (r) {
                                            grid.reload();
                                        });
                                } else {
                                    Swal.fire("Error", res.meta.message, "error");
                                }
                            });
                    }
                })
        }

        function showDetail() {
            $("#data-list").fadeOut(250, function () { $("#data-detail").fadeIn(500) });
        }

        function showList() {
            $("#data-detail").fadeOut(250, function () { $("#data-list").fadeIn(500) });
        }

        function save() {
            var url = "/Bank/" + (state === "new" ? "Insert" : "Update");
            axios.post(url, { bank: scope.bank })
                .then(function (res) { return res.data; }, function (err) { console.log("Err: ", er); })
                .then(function (res) {
                    if (res.meta.success) {
                        Swal.fire("Success", "Save data success", "success")
                            .then(function (r) {
                                showList();
                                grid.reload();
                            });
                    } else {
                        Swal.fire("Error", res.meta.message, "error");
                    }
                });
        }

        $("#btn-select-account").click(function () { $("#select-account").modal(); });
        $("#btn-add").click(addNew);
        $("#btn-back").click(function () { showList(); });
        $("#btn-save").click(save);
    }());
    </script>
}